package modello;

/**
 * Verificatore di parole che cerca una parola nella matrice, l'implementazione è fattibile in vari modi quindi la considero instabile 
 * e la isolo dal gestore {@link Partita}, in questo modo può essere reimplementata facilmente in una revisione del progetto
 * @author esame_16
 *
 */
public interface IVerificaParola {
	
	/**
	 * verifica la presenza di una parola nella matrice e ne stabilisce i punti corrispondenti
	 * @param matrice matrice di lettere
	 * @param parola parola da cercare
	 * @return punteggio assegnato alla parola
	 */
	public int verificaParola(char[][] matrice, String parola);

}
