package labirinto;

/**
 * l'index in origine avrebbe potuto servire per indicare la direzione del muro,
 * ma durante losviluppo si è deciso di conservarlo per poi modificarlo per
 * ad-hoc per implementare il passaggio Interdimentsionale (type 4)
 * 
 * @author koelio
 * @param type
 *            tipo di muro: 1 = muro, 2 = porta, 3 = baratro, 4 = passaggio
 *            interdim;
 * @param teleport
 *            in origine per la direzione, dopo per indicare la stanza di salto.
 *            Essa è definita come l'i-esima stanza contando da sinistra dalla prima stanza:
 *            (0,0) = #1 (1,0) = #2 e così via a mo' di serpentina
 * 
 */
public class Muro {

	private int[] teleport = new int[2];
	private int type;

	public Muro(int[] teleport, int type) {
		// super();
		this.teleport = teleport;
		this.type = type;

	}

	public Muro clone() {
		return new Muro(this.teleport, this.type);
	}

	public void setType(int type) {
		this.type = type;
	}

	public int getType() {
		return this.type;
	}

	public void setTeleport(int[] teleport) {
		this.teleport = teleport;
	}

	public int[] getTeleport() {
		return this.teleport;
	}
}
