package no.ntnu.it1901.resturant.UI;

import java.awt.event.ActionEvent;

/**
 * Includes resizePanel(), repaintPanel(), requestRefresh();
 * @author ghenrik
 *
 */
public interface PanelAdjustment {
	/**
	 * Gives the call to resize panel by given width and height
	 */
	public abstract void resizePanel(int width, int height);
	/**
	 * Gives the call to repaint/redraw the panel
	 */
	public abstract void repaintPanel();
	/**
	 * Gives the call to further call elements the panel requires to stay up to date with new information.
	 */
	public abstract void requestRefresh();
	/**
	 * Update the panel according to opCode transfered
	 */
	public abstract void action(int opCode);
}
