package data;

import java.util.Date;

/**
 * Bean representing a user of the system. 
 *
 * Attention: THE ROLE ATTRIBUTE IS NOT IMPLEMENTED
 * 
 * 
 * @author Ferdinand Kaiser, 05.04.08
 *
 */
public class User {

	private Long id;
	private String firstName;
	private String lastName;
	private String emailAddress;
	private String nickName;
	private String password;
	private Date lastLogin;
	private Date creationDate;
	private boolean deleted;
	
	public Long getId() {
		return id;
	}
	
	/**
	 * this method is set private to avoid database inconsistency,
	 * however Hibernate can access this method
	 * @param id objects unique id
	 */
	private void setId(Long id) {
		this.id = id;
	}
	
	public String getFirstName() {
		return firstName;
	}
	
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	
	public String getLastName() {
		return lastName;
	}
	
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	public String getEmailAddress() {
		return emailAddress;
	}
	
	public void setEmailAddress(String emailAddress) {
		this.emailAddress = emailAddress;
	}
	
	public String getNickName() {
		return nickName;
	}
	
	public void setNickName(String nickName) {
		this.nickName = nickName;
	}
	
	public Date getLastLogin() {
		return lastLogin;
	}
	
	public void setLastLogin(Date lastLogin) {
		this.lastLogin = lastLogin;
	}
		
	public Date getCreationDate() {
		return creationDate;
	}
	
	public void setCreationDate(Date creationDate) {
		this.creationDate = creationDate;
	}
		
	public String getPassword() {
		return password;
	}
	
	public void setPassword(String password) {
		this.password = password;
	}
	
	public boolean isDeleted() {
		return deleted;
	}
	
	public void setDeleted(boolean deleted) {
		this.deleted = deleted;
	}
	
}
