/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.ohell.threads;

/**
 * This is interface that should be implemented by ChatObservers
 * The chat observers are subscribed to a GameTable and they receive update calls
 * when the GameTable changes its state in terms of Chat communication - that is , if one player thread
 * sends communication chat messages , the GameTable will call all other observers'
 * updateWithChatObject() method.
 * 
 * @author vasko
 */
public interface OhellCommunicationObserver {

    /**
     * This is the update method of the Observer that is attached to the Table's Chat and its states
     * in terms of receiving chat messages from different players
     * @param chatPbject - the chat
     */
    public void sendObject(Object o);
}
