package model;

public interface TileTranslator
{
    /**
     * TileTranslator
     * 
     * Translates a map into a set of MagicTiles for viewing by the View.
     * 
     * @author adamszp
     */
    public MagicTile[][] getMagicTiles( int x, int y, int w, int h );
    
    public int getMapWidth();
    
    public int getMapHeight();
    
    public int getResourceCount( ResourceType resource ); // Deviation: View
                                                          // needs to know the
                                                          // resource count
}
