/*
 * File: ArmyArgs.java
 */

package model.interfaces.commandTypes;

/**
 * Implemented by commands that require an army ID as an argument.
 * 
 * @author Christopher Dudley
 */
public interface ArmyArgs
{
    
    /**
     * Sets the ID for the army that is the target of the command.
     * 
     * @param armyID
     *            the ID number of the army being targeted by the command.
     */
    public void setArgs( int armyID );
}
