package com.ouroboroswiki.core;

public interface AuthenticationManager {
	
	/**
	 * Authenticates a username/password
	 * @param username the unique user name
	 * @param password the secret credentials
	 * @return the principal if the authentication is successful, null if it is invalid
	 * @throws AuthenticationException if the authentication could not be checked
	 */
	Object authenticate( String username, String password ) throws AuthenticationException;
}
