package gui;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EtchedBorder;
import java.awt.Font;
import java.awt.SystemColor;
import javax.swing.UIManager;

public class GUIprincipal extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel contentPane;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GUIprincipal frame = new GUIprincipal();
					frame.setVisible(true);
					frame.setLocationRelativeTo(null);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public GUIprincipal() {
		setTitle("BELLA SOFT");
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 708, 505);
		contentPane = new JPanel();
		contentPane.setForeground(new Color(153, 0, 153));
		contentPane.setBackground(new Color(153, 0, 153));
		contentPane.setBorder(new CompoundBorder());
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setForeground(new Color(153, 0, 153));
		panel.setBackground(new Color(139, 0, 139));
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED, SystemColor.controlHighlight, null));
		panel.setBounds(24, 21, 653, 428);
		contentPane.add(panel);
		panel.setLayout(null);
		
		////BOTO USUARIO
		
		JButton btnUsuario = new JButton("Usu\u00E1rio");
		btnUsuario.setIcon(new ImageIcon(GUIprincipal.class.getResource("/imagens/usuarios.png")));
		btnUsuario.setToolTipText("");
		btnUsuario.setBackground(new Color(153, 0, 153));
		btnUsuario.setForeground(UIManager.getColor("CheckBox.background"));
		btnUsuario.setFont(new Font("Batang", Font.BOLD, 19));
		btnUsuario.setBounds(27, 27, 159, 37);
		panel.add(btnUsuario);
		btnUsuario.addMouseListener(new MouseAdapter() {
		});
		btnUsuario.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				MostrarTelaUsuario();
		}
		});
		
		////BOTO CLIENTE
		
		JButton btnCliente = new JButton("Clientes");
		btnCliente.setToolTipText("");
		btnCliente.setBackground(new Color(153, 0, 153));
		btnCliente.setForeground(UIManager.getColor("CheckBox.background"));
		btnCliente.setFont(new Font("Batang", Font.BOLD, 19));
		btnCliente.setBounds(27, 75, 159, 37);
		panel.add(btnCliente);
		btnCliente.addMouseListener(new MouseAdapter() {
		});
		btnCliente.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {	
				MostrarTelaCliente();
			}
			void MostrarTelaCliente(){
				GUIcliente telaCliente = new GUIcliente();
				telaCliente.setVisible(true);
				telaCliente.setLocationRelativeTo(null);
			}	
		});
				
	////BOTAO FUNCIONARIOS
		
			JButton btnFuncionario = new JButton("Funcion\u00E1rios");
			btnFuncionario.setToolTipText("");
			btnFuncionario.setBackground(new Color(153, 0, 153));
			btnFuncionario.setForeground(UIManager.getColor("CheckBox.background"));
			btnFuncionario.setFont(new Font("Batang", Font.BOLD, 19));
			btnFuncionario.setBounds(27, 123, 159, 37);
			panel.add(btnFuncionario);
			btnFuncionario.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					MostrarTelaFuncionario();
				}
				void MostrarTelaFuncionario(){
					GUIfuncionario telaFuncionario = new GUIfuncionario();
					telaFuncionario.setVisible(true);
					telaFuncionario.setLocationRelativeTo(null);
				}
			});
		
		////BOTAO FORNECEDORES
			
			JButton btnFornecedores = new JButton("Fornecedores");
			btnFornecedores.setToolTipText("");
			btnFornecedores.setBackground(new Color(153, 0, 153));
			btnFornecedores.setForeground(UIManager.getColor("CheckBox.background"));
			btnFornecedores.setFont(new Font("Batang", Font.BOLD, 19));
			btnFornecedores.setBounds(27, 171, 159, 37);
			panel.add(btnFornecedores);
			btnFornecedores.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					MostrarTelaFornecedor();
				}
				void MostrarTelaFornecedor(){
					GUIfornecedor telaFornecedor = new GUIfornecedor();
					telaFornecedor.setVisible(true);
					telaFornecedor.setLocationRelativeTo(null);
				}
				
			});
			
		////BOTAO SERVICOS
		
			JButton btnServico = new JButton("Servi\u00E7os");
			btnServico.setToolTipText("");
			btnServico.setBackground(new Color(153, 0, 153));
			btnServico.setForeground(UIManager.getColor("CheckBox.background"));
			btnServico.setFont(new Font("Batang", Font.BOLD, 19));
			btnServico.setBounds(27, 219, 159, 37);
			panel.add(btnServico);		
			btnServico.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					MostrarTelaServico();
				}
				private void MostrarTelaServico() {
					GUIservico telaServico = new GUIservico();
					telaServico.setVisible(true);
					telaServico.setLocationRelativeTo(null);
				}
			});
		
		////BOTO PRODUTOS
		
		JButton btnProdutos = new JButton("Produtos");
		btnProdutos.setToolTipText("");
		btnProdutos.setBackground(new Color(153, 0, 153));
		btnProdutos.setForeground(UIManager.getColor("CheckBox.background"));
		btnProdutos.setFont(new Font("Batang", Font.BOLD, 19));
		btnProdutos.setBounds(27, 267, 159, 37);
		panel.add(btnProdutos);
		btnProdutos.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				MostrarTelaProduto();
			}
			private void MostrarTelaProduto() {
				GUIproduto telaProduto = new GUIproduto();
				telaProduto.setVisible(true);
				telaProduto.setLocationRelativeTo(null);
			}
		});
		
		
		////BOTAO AGENDA
		
		JButton btnAgenda = new JButton("Agenda");
		btnAgenda.setToolTipText("");
		btnAgenda.setBackground(new Color(153, 0, 153));
		btnAgenda.setForeground(UIManager.getColor("CheckBox.background"));
		btnAgenda.setFont(new Font("Batang", Font.BOLD, 19));
		btnAgenda.setBounds(27, 317, 159, 37);
		panel.add(btnAgenda);
		btnAgenda.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				MostrarTelaAgenda();
			}
			private void MostrarTelaAgenda() {
				GUIagenda telaAgenda = new GUIagenda();
				telaAgenda.setVisible(true);
				telaAgenda.setLocationRelativeTo(null);
			}
		});
		
		////BOTAO CALCULADORA
		
		JButton btnCalculadora = new JButton("Calculadora");
		btnCalculadora.setToolTipText("");
		btnCalculadora.setBackground(new Color(153, 0, 153));
		btnCalculadora.setForeground(UIManager.getColor("CheckBox.background"));
		btnCalculadora.setFont(new Font("Batang", Font.BOLD, 19));
		btnCalculadora.setBounds(27, 365, 159, 37);
		panel.add(btnCalculadora);
		btnCalculadora.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				MostrarTelaCalculadora();
			}
			private void MostrarTelaCalculadora() {
				Calculadora telaCalculadora = new Calculadora();
				telaCalculadora.setVisible(true);
				telaCalculadora.setLocationRelativeTo(null);
				
			}
		});
		
		////BOTAO SAIR 
		
		JButton btnNewButton_3 = new JButton("Sair");
		btnNewButton_3.setFont(new Font("MS PGothic", Font.PLAIN, 14));
		btnNewButton_3.setForeground(new Color(204, 204, 204));
		btnNewButton_3.setBackground(new Color(153, 0, 153));
		btnNewButton_3.setIcon(new ImageIcon(GUIprincipal.class.getResource("/imagens/sair.png")));
		btnNewButton_3.setBounds(528, 386, 101, 32);
		panel.add(btnNewButton_3);
		
		JLabel lblNewLabel = new JLabel("");
		lblNewLabel.setIcon(new ImageIcon(GUIprincipal.class.getResource("/imagens/Bellasof.jpg")));
		lblNewLabel.setBounds(224, 86, 360, 298);
		panel.add(lblNewLabel);
		btnNewButton_3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				
				System.exit(0);
			}
		});
		
		////Painel Menu de Opoes
		
				
		JLabel lblMenuDeOpoes = new JLabel("Menu de Op\u00E7oes");
		lblMenuDeOpoes.setBackground(SystemColor.controlHighlight);
		lblMenuDeOpoes.setForeground(SystemColor.controlHighlight);
		lblMenuDeOpoes.setFont(new Font("Curlz MT", Font.PLAIN, 45));
		lblMenuDeOpoes.setBounds(247, 11, 305, 77);
		panel.add(lblMenuDeOpoes);
		
		
	}
	
	
	
	
	void MostrarTelaUsuario(){
		GUICadastroUsuario telaCadastroUsuario = new GUICadastroUsuario();
		telaCadastroUsuario.setVisible(true);
		telaCadastroUsuario.setLocationRelativeTo(null);
	}

}	