package boccuz.rnn;

import java.util.Locale;

/**
 * <h1>The settings container</h1>
 * <p>
 * There is two types of settings : static and dynamics. Static settings cannot
 * be modified by the player.
 * </p>
 */
public abstract class Settings {
	/** Screen width */
	public static final int WIDTH = 800;
	/** Screen height */
	public static final int HEIGHT = 600;
	/** Full screen flag */
	public static final boolean FULL_SCREEN = false;

	/** The text locale */
	public static Locale CURRENT_LOCALE = Locale.FRENCH;
	/** Debug mode */
	public static boolean IS_DEBUG = false;
	/** No cost mode */
	public static boolean NO_COST = false;
	/** All techs mode */
	public static boolean ALL_TECHNOLOGIES = false;
}
