package org.rlcommunity.critter.Controls;

import org.rlcommunity.critter.Base.Vector2D;

/** Interface defining the sensors and controls of a two wheeled robot */
public interface TwoWheeledRobot {
	// Setting control values 
	
	void setTorques( double torqueL, double torqueR );

	// Getting sensor values
	
	double getLightL();
	double getLightR();
	double getLightM();
	double getAngleL();
	double getAngleR();
	double getVelL();
	double getVelR();

	Vector2D getPosition();
	double getDirection();
}
