/*******************************************************************************
 * Portions created by Sebastian Thomschke are copyright (c) 2005-2010 Sebastian
 * Thomschke.
 * 
 * All Rights Reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Sebastian Thomschke - initial implementation.
 *******************************************************************************/
package wrm.saferJava.oval.context;

import java.lang.reflect.Method;

import wrm.saferJava.oval.internal.util.SerializableMethod;


/**
 * @author Sebastian Thomschke
 */
public class MethodReturnValueContext extends OValContext
{
	private static final long serialVersionUID = 1L;

	private final SerializableMethod method;

	public MethodReturnValueContext(final Method method)
	{
		this.method = SerializableMethod.getInstance(method);
		this.compileTimeType = method.getReturnType();
	}

	/**
	 * @return Returns the getter.
	 */
	public Method getMethod()
	{
		return method.getMethod();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString()
	{
		return method.getDeclaringClass().getName() + "." + method.getName() + "()";
	}
}
