/**
 *  Serponix is an arcade game in focus to multiplayer based on the classic game Snake.
 *  Copyright (C) 2010 - 2011  Daniel Vala
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License,
 *  or  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  If you have any question do not hesitate to contact author
 *  on e-mail address: danielvala42@gmail.com
 */
package com.serponix.abilities;

import com.serponix.game.ModelFun;
import com.serponix.game.Snake;

/**
 * Vlastnost pivo z hada udělá hada opilého.
 * Při pokynu zatočení do jednoho směru vždy zatočí do směru opačného.
 *
 * @author Daniel Vala
 */
public class Pivo extends Ability {

	/**
	 * Vytvoří vlastnost pivo s danou vzácností.
	 *
	 * @param sance Určuje, jak často se bude vlastnost generovat.
	 */
	public Pivo(int sance) {
		super(sance);
	}

	@Override
	public boolean proved(ModelFun model, Snake had) {
		if (had.isVlastnostObraceneKlavesy()) {
			model.getPanelZprav().addMessage(String.format("%s vypil další pivo a bude déle opilý!", had));
		} else {
			model.getPanelZprav().addMessage(String.format("%s vypil pivo a je nyní opilý!", had));
		}
		had.setVlastnostObraceneKlavesy(true);
		return true;
	}
}
