/**
 *  Serponix is an arcade game in focus to multiplayer based on the classic game Snake.
 *  Copyright (C) 2010 - 2011  Daniel Vala
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License,
 *  or  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  If you have any question do not hesitate to contact author
 *  on e-mail address: danielvala42@gmail.com
 */
package com.serponix.abilities;

import com.serponix.game.ModelFun;
import com.serponix.game.Snake;

/**
 * Vlastnost tabletka dodá hadovi vitalitu.
 * Při konzumaci jídla roste rychleji.
 *
 * @author Daniel Vala
 */
public class Tabletka extends Ability {

	/**
	 * Vytvoří vlastnost tabletka s danou vzácností.
	 *
	 * @param sance Určuje, jak často se bude vlastnost generovat.
	 */
	public Tabletka(int sance) {
		super(sance);
	}

	/**
	 * Had zrychlí svůj růst o 1.
	 * Po každé konzumaci jídla vyroste více.
	 *
	 * @param model Model hry.
	 * @param had   Had, který zrychlí svůj růst.
	 * @return Had vždy může zrychlit svůj růst, proto true.
	 */
	public boolean proved(ModelFun model, Snake had) {
		had.addVitalita(1);
		model.getPanelZprav().addMessage(String.format("%s sežral tabletku růstu.", had));
		return true;
	}
}
