/**
 *  Serponix is an arcade game in focus to multiplayer based on the classic game Snake.
 *  Copyright (C) 2010 - 2011  Daniel Vala
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License,
 *  or  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  If you have any question do not hesitate to contact author
 *  on e-mail address: danielvala42@gmail.com
 */
package com.serponix.game.editor;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

/**
 * Obsluhuje klávesy pro uložení, načtení a smazání mapy.
 * Klávesou ESCAPE lze přejít zpět do hlavního menu.
 *
 * @author Daniel Vala
 */
public class KeyControllerEditor extends KeyAdapter {

	private ModelEditor model;

	public KeyControllerEditor(ModelEditor model) {
		this.model = model;
	}

	@Override
	public void keyPressed(KeyEvent event) {
		int key = event.getKeyCode();
		if (key == KeyEvent.VK_S) {
			model.ulozMapu();
		}
		if (key == KeyEvent.VK_L) {
			model.nactiMapu();
		}
		if (key == KeyEvent.VK_DELETE) {
			model.smazMapu();
		}
		if (key == KeyEvent.VK_ESCAPE) {
			model.ukonciEditor();
		}
	}
}
