/**
 *  Serponix is an arcade game in focus to multiplayer based on the classic game Snake.
 *  Copyright (C) 2010 - 2011  Daniel Vala
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License,
 *  or  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  If you have any question do not hesitate to contact author
 *  on e-mail address: danielvala42@gmail.com
 */
package com.serponix.gui.settings;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

/**
 * Controller nastaví všechny hodnoty do původního stavu,
 * ale neuloží je do souboru.
 *
 * @author Daniel Vála
 */
public class SetDefaultController implements ActionListener {

	private ModelNastaveni model;

	public SetDefaultController(ModelNastaveni model) {
		this.model = model;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		int vysledek = JOptionPane.showConfirmDialog(null, "Opravdu chcete nastavit všechny hodnoty do výchozího stavu?", "Upozornění", JOptionPane.YES_NO_OPTION);
		if (vysledek != 0) {
			return;
		}
		model.setDefault();
	}
}
