package org.simplextensions.ui.menu;

import org.simplextensions.registry.Extension;
import org.simplextensions.registry.IExtensionValidator;

/**
 * 
 * 
 * @author Tomasz Krzyak, <a
 *         href="mailto:tomasz.krzyzak@gmail.com">tomasz.krzyzak@gmail.com</a>
 * @since 2010-05-10 09:58:13
 */
public class MenuExtensionValidator implements IExtensionValidator {

	public boolean isValid(Extension extension) {
		Integer integerValue = extension.getPropertyValue(MenuExtensionPoint.TYPE).getIntegerValue();
		if (extension.getPropertyValue(MenuExtensionPoint.ID).getStringValue() == null)
			return false;
		if (extension.getPropertyValue(MenuExtensionPoint.ORDER).getIntegerValue() == null)
			return false;

		if (integerValue != null) {
			if (integerValue.equals(MenuExtensionType.Action)) {
				if (extension.getPropertyValue(MenuExtensionPoint.PARENT).getStringValue() == null)
					return false;
			} else if (integerValue.equals(MenuExtensionType.Menu)) {

			} else if (integerValue.equals(MenuExtensionType.Separator)) {
				if (extension.getPropertyValue(MenuExtensionPoint.PARENT).getStringValue() == null)
					return false;
			}
		}
		return false;
	}

}
