package org.simplextensions.registry;

import java.lang.annotation.Annotation;
import java.util.Set;

import org.simplextensions.registry.phaselisteners.IDependencyLocator;

/**
 * 
 * @author Mirek Szajowski m.szajowski@gmail.com
 * 
 */
public interface IDependencyLocatorRegistry {

	/**
	 * Returns service locator class connected with given annotation
	 * 
	 * @param annotation
	 * @return
	 */
	IDependencyLocator findDependencyLocator(Class<? extends Annotation> annotation);

	IExtensionRegistry getExtensionRegistry();

	Set<Class<? extends Annotation>> getSupportedAnnotations();
}
