package org.simplextensions.registry;

/**
 * 
 * @author krzyzak
 * 
 */
public interface IServiceLocator {

	/**
	 * 
	 * @param <T>
	 * @param serviceRegistry
	 * @param serviceInterface
	 * @return service providing functionality defined by given interface or
	 *         null if no such service exists
	 */
	<T> T getService(IServiceRegistry serviceRegistry, Class<T> serviceInterface);
	
	void start(IServiceRegistry serviceRegistry);
	
	void stop(IServiceRegistry serviceRegistry);

}
