/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

package org.huihoo.orbas.idl;

public class str_token extends java_cup.runtime.str_token implements
		java.io.Serializable {

	public String str_val;
	public String line_val;
	public int line_no;
	public int char_pos;
	public String pragma_prefix = "";
	public String fileName = "";

	/** Full constructor. */
	public str_token(int term_num, String v, PositionInfo p, String _fileName) {
		/* super class does most of the work */
		super(term_num);

		str_val = v;
		line_val = p.line;
		line_no = p.line_no;
		char_pos = p.line_pos;
		pragma_prefix = p.pragma_prefix;
		fileName = _fileName;
	}

	/** Constructor for value defaulting to an empty string. */
	public str_token(int term_num) {
		this(term_num, "", lexer.getPosition(), GlobalInputStream.currentFile()
				.getName());
	}

}
