/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

package org.huihoo.orbas.orb.protocols;

/**
 * <p>Description: </p>
 * A creator for profiles.
 * <p>Copyright (c) 2002,2003</p>
 * <p>Company: <a href="http://www.huihoo.org/">huihoo.org</a></p>
 * @author <a href="http://www.huihoo.org/~mep">mep(mep@huihoo.com)</a>
 * @see <a href="http://www.huihoo.org/orbas">http://www.huihoo.org/orbas</a>
 * @version 1.0
 */

import org.huihoo.orbas.orb.cdr.CDROutputStream;

public abstract class ProfileCreator {
	protected CDROutputStream out;

	// protected byte[] objectKey;

	public ProfileCreator(CDROutputStream out) {
		this.out = out;
	}

	public ProfileCreator() {

	}

	public void setOutputStream(CDROutputStream out) {
		this.out = out;
	}

	// public void setObjectKey(byte[] objectKey) {
	// this.objectKey = objectKey;
	// }

	public abstract Channel createChannel();

	public abstract org.omg.IOP.TaggedProfile[] createProfiles(
			byte[] objectKey, int version);
}