/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

package org.huihoo.orbas.orb.protocols;

/**
 * <p>Description: </p>
 * Profile extractor.
 * <p>Copyright (c) 2002,2003</p>
 * <p>Company: <a href="http://www.huihoo.org/">huihoo.org</a></p>
 * @author <a href="http://www.huihoo.org/~mep">mep(mep@huihoo.com)</a>
 * @see <a href="http://www.huihoo.org/orbas">http://www.huihoo.org/orbas</a>
 * @version 1.0
 */

import org.huihoo.orbas.orb.cdr.CDRInputStream;

public abstract class ProfileExtractor {

	protected CDRInputStream in;

	public ProfileExtractor(CDRInputStream in) {
		this.in = in;
	}

	public ProfileExtractor() {

	}

	public abstract TargetAddress getTargetAddress();

	public abstract byte[] getObjectKey();

	public void setInputStream(CDRInputStream in) {
		this.in = in;
	}

	public abstract void parse();

	public abstract int getVersion();
}