/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

package org.huihoo.orbas.orb.protocols;

/**
 * <p>
 * Description:
 * </p>
 * Registry for all profile dealers.
 * <p>
 * Copyright (c) 2002,2003
 * </p>
 * <p>
 * Company: <a href="http://www.huihoo.org/">huihoo.org</a>
 * </p>
 * 
 * @author <a href="http://www.huihoo.org/~mep">mep(mep@huihoo.com)</a>
 * @see <a href="http://www.huihoo.org/orbas">http://www.huihoo.org/orbas</a>
 * @version 1.0
 */

public class ProfileRegistry {

	java.util.Hashtable extractors;
	java.util.Hashtable creators;

	public ProfileRegistry() {
		extractors = new java.util.Hashtable();
		creators = new java.util.Hashtable();
	}

	public void registerProfileDealer(int tag, ProfileCreator creator,
			ProfileExtractor extractor) {
		creators.put(new Integer(tag), creator);
		extractors.put(new Integer(tag), extractor);
	}

	public ProfileExtractor getProfileExtractor(int tag) {
		return (ProfileExtractor) extractors.get(new Integer(tag));
	}

	public ProfileCreator getProfileCreator(int tag) {
		return (ProfileCreator) creators.get(new Integer(tag));
	}
}