/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

/* Generated by Together */

package org.huihoo.orbas.orb.typecode;

/**
 * <p>Description: </p>
 * TypeCode factory implementation.
 * <p>Copyright (c) 2002,2003</p>
 * <p>Company: <a href="http://www.huihoo.org/">huihoo.org</a></p>
 * @author <a href="http://www.huihoo.org/~mep">mep(mep@huihoo.com)</a>
 * @see <a href="http://www.huihoo.org/orbas">http://www.huihoo.org/orbas</a>
 * @version 1.0
 */

import org.omg.CORBA.StructMember;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.UnionMember;
import org.omg.CORBA.ValueMember;

public class TypeCodeFactory_impl extends org.huihoo.orbas.orb.TypeCodeFactory {

	public org.omg.CORBA.TypeCode get_primitive_tc(org.omg.CORBA.TCKind tcKind) {
		// implementation here
		return new TypeCodePrimitive(tcKind);
	}

	public TypeCode create_struct_tc(String id, String name,
			StructMember[] members) {
		return new TypeCodeStruct(id, name, members);
	}

	public TypeCode create_union_tc(String id, String name,
			TypeCode discriminator_type, UnionMember[] members) {
		return new TypeCodeUnion(id, name, discriminator_type, members);
	}

	public TypeCode create_enum_tc(String id, String name, String[] members) {
		return new TypeCodeEnum(id, name, members);
	}

	public TypeCode create_alias_tc(String id, String name,
			TypeCode original_type) {
		return new TypeCodeAlias(id, name, original_type);
	}

	public TypeCode create_exception_tc(String id, String name,
			StructMember[] members) {
		return new TypeCodeException(id, name, members);
	}

	public TypeCode create_interface_tc(String id, String name) {
		return new TypeCodeInterface(id, name);
	}

	public TypeCode create_string_tc(int bound) {
		return new TypeCodeString(bound);
	}

	public TypeCode create_wstring_tc(int bound) {
		return new TypeCodeWString(bound);
	}

	public org.omg.CORBA.TypeCode create_fixed_tc(short digits, short scale) {
		return new TypeCodeFixed(digits, scale);
	}

	public org.omg.CORBA.TypeCode create_sequence_tc(int bound,
			TypeCode element_type) {
		return new TypeCodeSequence(bound, element_type);
	}

	/** @deprecated by CORBA 2.3 */
	public org.omg.CORBA.TypeCode create_recursive_sequence_tc(int bound,
			int offset) {
		return new TypeCodeRecursiveSequence(bound, offset);
	}

	public org.omg.CORBA.TypeCode create_array_tc(int length,
			TypeCode element_type) {
		return new TypeCodeArray(length, element_type);
	}

	public org.omg.CORBA.TypeCode create_value_tc(String id, String name,
			short type_modifier, TypeCode concrete_base, ValueMember[] members) {
		return new TypeCodeValue(id, name, type_modifier, concrete_base,
				members);
	}

	public org.omg.CORBA.TypeCode create_value_box_tc(String id, String name,
			TypeCode boxed_type) {
		return new TypeCodeValueBox(id, name, boxed_type);
	}

	public org.omg.CORBA.TypeCode create_native_tc(String id, String name) {
		return new TypeCodeNative(id, name);
	}

	public org.omg.CORBA.TypeCode create_recursive_tc(String id) {
		return new TypeCodeRecursive(id);
	}

	public org.omg.CORBA.TypeCode create_abstract_interface_tc(String id,
			String name) {
		return new TypeCodeAbstractInterface(id, name);
	}

	public org.omg.CORBA.TypeCode create_local_interface_tc(String id,
			String name) {
		return new TypeCodeLocalInterface(id, name);
	}
}
