/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

package org.huihoo.orbas.orb.typecode;

/**
 * <p>
 * Description:
 * </p>
 * TypeCode for recursive, deprecated.
 * <p>
 * Copyright (c) 2002,2003
 * </p>
 * <p>
 * Company: <a href="http://www.huihoo.org/">huihoo.org</a>
 * </p>
 * 
 * @author <a href="http://www.huihoo.org/~mep">mep(mep@huihoo.com)</a>
 * @see <a href="http://www.huihoo.org/orbas">http://www.huihoo.org/orbas</a>
 * @version 1.0
 */

public class TypeCodeRecursive extends TypeCodeBase {

	String id;

	public TypeCodeRecursive(String id) {
		this.id = id;
	}

	public boolean equal(org.omg.CORBA.TypeCode tc) {
		if (this == tc) {
			return true;
		}

		try {
			if (tc.id() == id) {
				return true;
			}
		} catch (org.omg.CORBA.TypeCodePackage.BadKind ex) {
			return false;
		}

		return false;
	}

	public org.omg.CORBA.TypeCode get_compact_typecode() {
		throw new org.omg.CORBA.BAD_TYPECODE(
				"Attempt to access incomplete typecode", 0,
				org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
	}

	public org.omg.CORBA.TCKind kind() {
		throw new org.omg.CORBA.BAD_TYPECODE(
				"Attempt to access incomplete typecode", 0,
				org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
	}

	public java.lang.String id() throws org.omg.CORBA.TypeCodePackage.BadKind {
		return id;
	}

	public java.lang.String name() throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.BAD_TYPECODE(
				"Attempt to access incomplete typecode", 0,
				org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
	}

	public int member_count() throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public java.lang.String member_name(int index)
			throws org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public org.omg.CORBA.TypeCode member_type(int index)
			throws org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public org.omg.CORBA.Any member_label(int index)
			throws org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public org.omg.CORBA.TypeCode discriminator_type()
			throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public int default_index() throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public int length() throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public org.omg.CORBA.TypeCode content_type()
			throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public short fixed_digits() throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public short fixed_scale() throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public short member_visibility(int index)
			throws org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public short type_modifier() throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}

	public org.omg.CORBA.TypeCode concrete_base_type()
			throws org.omg.CORBA.TypeCodePackage.BadKind {
		throw new org.omg.CORBA.NO_IMPLEMENT();
	}
}
