/*
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.xfuze.model;

import java.util.Date;

import org.xfuze.lang.ChangeType;

/**
 * @see org.xfuze.util.Audit
 * @author Jason Chan
 *
 */
public interface AuditAwareModel extends Model {
	public Date getChangeTime();

	public void setChangeTime(Date changeTime);

	public ChangeType getChangeType();

	public void setChangeType(ChangeType changeType);

	public String getOldUpdatedBy();

	public void setOldUpdatedBy(String oldUpdatedBy);

	public String getNewUpdatedBy();

	public void setNewUpdatedBy(String newUpdatedBy);

	public Date getOldUpdatedDate();

	public void setOldUpdatedDate(Date oldUpdatedDate);

	public Date getNewUpdatedDate();

	public void setNewUpdatedDate(Date newUpdatedDate);
}
