/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

package org.huihoo.orbas.orb;

public class InputStream extends org.omg.CORBA.LocalObject implements
		org.omg.CORBA.DataInputStream {
	private org.omg.CORBA.portable.InputStream input;

	public InputStream(org.omg.CORBA.portable.InputStream istream) {
		input = istream;
	}

	public String[] _truncatable_ids() {
		return null;
	}

	public org.omg.CORBA.Any read_any() {
		return input.read_any();
	}

	public boolean read_boolean() {
		return input.read_boolean();
	}

	public char read_char() {
		return input.read_char();
	}

	public char read_wchar() {
		return input.read_wchar();
	}

	public byte read_octet() {
		return input.read_octet();
	}

	public short read_short() {
		return input.read_short();
	}

	public short read_ushort() {
		return input.read_ushort();
	}

	public int read_long() {
		return input.read_long();
	}

	public int read_ulong() {
		return input.read_ulong();
	}

	public long read_longlong() {
		return input.read_longlong();
	}

	public long read_ulonglong() {
		return input.read_ulonglong();
	}

	public float read_float() {
		return input.read_float();
	}

	public double read_double() {
		return input.read_double();
	}

	public java.lang.String read_string() {
		return input.read_string();
	}

	public java.lang.String read_wstring() {
		return input.read_wstring();
	}

	public org.omg.CORBA.Object read_Object() {
		return input.read_Object();
	}

	public java.lang.Object read_Abstract() {
		return ((org.omg.CORBA_2_3.portable.InputStream) input)
				.read_abstract_interface();
	}

	public java.io.Serializable read_Value() {
		return ((org.omg.CORBA_2_3.portable.InputStream) input).read_value();
	}

	public org.omg.CORBA.TypeCode read_TypeCode() {
		return input.read_TypeCode();
	}

	public void read_any_array(org.omg.CORBA.AnySeqHolder seq, int offset,
			int length) {
		for (int i = offset; i < offset + length; i++)
			seq.value[i] = input.read_any();
	}

	public void read_boolean_array(org.omg.CORBA.BooleanSeqHolder seq,
			int offset, int length) {
		input.read_boolean_array(seq.value, offset, length);
	}

	public void read_char_array(org.omg.CORBA.CharSeqHolder seq, int offset,
			int length) {
		input.read_char_array(seq.value, offset, length);
	}

	public void read_wchar_array(org.omg.CORBA.WCharSeqHolder seq, int offset,
			int length) {
		input.read_wchar_array(seq.value, offset, length);
	}

	public void read_octet_array(org.omg.CORBA.OctetSeqHolder seq, int offset,
			int length) {
		input.read_octet_array(seq.value, offset, length);
	}

	public void read_short_array(org.omg.CORBA.ShortSeqHolder seq, int offset,
			int length) {
		input.read_short_array(seq.value, offset, length);
	}

	public void read_ushort_array(org.omg.CORBA.UShortSeqHolder seq,
			int offset, int length) {
		input.read_ushort_array(seq.value, offset, length);
	}

	public void read_long_array(org.omg.CORBA.LongSeqHolder seq, int offset,
			int length) {
		input.read_long_array(seq.value, offset, length);
	}

	public void read_ulong_array(org.omg.CORBA.ULongSeqHolder seq, int offset,
			int length) {
		input.read_ulong_array(seq.value, offset, length);
	}

	public void read_longlong_array(org.omg.CORBA.LongLongSeqHolder seq,
			int offset, int length) {
		input.read_longlong_array(seq.value, offset, length);
	}

	public void read_ulonglong_array(org.omg.CORBA.ULongLongSeqHolder seq,
			int offset, int length) {
		input.read_ulonglong_array(seq.value, offset, length);
	}

	public void read_float_array(org.omg.CORBA.FloatSeqHolder seq, int offset,
			int length) {
		input.read_float_array(seq.value, offset, length);
	}

	public void read_double_array(org.omg.CORBA.DoubleSeqHolder seq,
			int offset, int length) {
		input.read_double_array(seq.value, offset, length);
	}

	public double read_longdouble() {
		return (double) 0.0;
	}
}