/* Orbas:
 *     A open source CORBA Specification implementation from Huihoo.
 *
 * Copyright 2002-2003 Huihoo.org, Inc. All Right Reserved.
 *
 * This software is licensed under LGPL license.
 * See terms of license at gnu.org.
 *
 * For more information, visit:
 *
 * http://www.huihoo.org/orbas
 */

package org.huihoo.orbas.orb;

public class OutputStream extends org.omg.CORBA.LocalObject implements
		org.omg.CORBA.DataOutputStream {

	private org.omg.CORBA.portable.OutputStream output;

	public OutputStream(org.omg.CORBA.portable.OutputStream ostream) {
		output = ostream;
	}

	public String[] _truncatable_ids() {
		return null;
	}

	public void write_any(org.omg.CORBA.Any value) {
		output.write_any(value);
	}

	public void write_boolean(boolean value) {
		output.write_boolean(value);
	}

	public void write_char(char value) {
		output.write_char(value);
	}

	public void write_wchar(char value) {
		output.write_wchar(value);
	}

	public void write_octet(byte value) {
		output.write_octet(value);
	}

	public void write_short(short value) {
		output.write_short(value);
	}

	public void write_ushort(short value) {
		output.write_ushort(value);
	}

	public void write_long(int value) {
		output.write_long(value);
	}

	public void write_ulong(int value) {
		output.write_ulong(value);
	}

	public void write_longlong(long value) {
		output.write_longlong(value);
	}

	public void write_ulonglong(long value) {
		output.write_ulonglong(value);
	}

	public void write_float(float value) {
		output.write_float(value);
	}

	public void write_double(double value) {
		output.write_double(value);
	}

	public void write_string(java.lang.String value) {
		output.write_string(value);
	}

	public void write_wstring(java.lang.String value) {
		output.write_wstring(value);
	}

	public void write_Object(org.omg.CORBA.Object value) {
		output.write_Object(value);
	}

	public void write_Abstract(java.lang.Object value) {
		((org.omg.CORBA_2_3.portable.OutputStream) output)
				.write_abstract_interface(value);
	}

	public void write_Value(java.io.Serializable value) {
		((org.omg.CORBA_2_3.portable.OutputStream) output).write_value(value);
	}

	public void write_TypeCode(org.omg.CORBA.TypeCode value) {
		output.write_TypeCode(value);
	}

	public void write_any_array(org.omg.CORBA.Any[] seq, int offset, int length) {
		for (int i = offset; i < offset + length; i++)
			output.write_any(seq[i]);
	}

	public void write_boolean_array(boolean[] seq, int offset, int length) {
		output.write_boolean_array(seq, offset, length);
	}

	public void write_char_array(char[] seq, int offset, int length) {
		output.write_char_array(seq, offset, length);
	}

	public void write_wchar_array(char[] seq, int offset, int length) {
		output.write_wchar_array(seq, offset, length);
	}

	public void write_octet_array(byte[] seq, int offset, int length) {
		output.write_octet_array(seq, offset, length);
	}

	public void write_short_array(short[] seq, int offset, int length) {
		output.write_short_array(seq, offset, length);
	}

	public void write_ushort_array(short[] seq, int offset, int length) {
		output.write_ushort_array(seq, offset, length);
	}

	public void write_long_array(int[] seq, int offset, int length) {
		output.write_long_array(seq, offset, length);
	}

	public void write_ulong_array(int[] seq, int offset, int length) {
		output.write_ulong_array(seq, offset, length);
	}

	public void write_longlong_array(long[] seq, int offset, int length) {
		output.write_longlong_array(seq, offset, length);
	}

	public void write_ulonglong_array(long[] seq, int offset, int length) {
		output.write_ulonglong_array(seq, offset, length);
	}

	public void write_float_array(float[] seq, int offset, int length) {
		output.write_float_array(seq, offset, length);
	}

	public void write_double_array(double[] seq, int offset, int length) {
		output.write_double_array(seq, offset, length);
	}

	public void write_longdouble(double value) {
	}
}